<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ taglib uri="http://www.zkoss.org/jsp/zul" prefix="z"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
		<title>Instant Message Board</title>
		<z:zkhead/>
		<style type="text/css">
			<%@include file="/resource/messageboard.css" %>
		</style>
	</head>
	<body>
		<div class="container">
			<div class="header"><!-- ********** Header ********** -->
				<h1 id="zk-logo">
					<img src="./resource/top_zk_logo.png" title="ZK Logo" alt="ZK Logo">
				</h1>
				<h1 id="topic">Instant Message Board</h1>
			</div>
			
			<div class="messages main-block"><!-- ********** left block ********** -->
				 <div class="messageboard-container">
				 	<div class="messageboard-static">
				 		<!-- ********** Static Content ********** -->
				 		<c:forEach var="message" items="${requestScope.messages}">
				 			<c:set var="message" value="${message}" scope="request"></c:set>
				 			<jsp:include page="/WEB-INF/_message.jsp"></jsp:include>
				 			<c:remove var="message"/>
				 		</c:forEach>
				 		
				 		<z:page><!-- ********** Expansion Area ********** -->
				 			<z:div use="demo.ExpansionArea" />
				 		</z:page>
				 	</div>
				 	<z:page>
				 		<!-- ********** View Control Area ********** -->
				 		<z:div apply="demo.MessageboardViewCtrl">
				 			<z:timer id="timer"/>
				 		</z:div>
				 	</z:page>
				 </div>
			</div>
			<div class="users main-block" ><!-- ********** right block ********** -->
				 <z:page><!-- ********** Attendees Panel View Ctrl **********-->
					<z:div sclass="users_div" apply="demo.AttendeesPanelViewCtrl">
						<z:button id="userBtn" label="Join"></z:button>
						<z:grid id="attendeesGrid" >
							<z:auxhead>
								<z:auxheader colspan="3">Users</z:auxheader>	
							</z:auxhead>
							<z:columns visible="false">
								<z:column width="60px"></z:column>
								<z:column width="200px"></z:column>
								<z:column></z:column>
							</z:columns>
						</z:grid>
					</z:div>
				 </z:page>
			</div>
		</div>
	</body>
</html>


