/**
 * 
 */
package demo;

import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.IdSpace;
import org.zkoss.zul.Div;
import org.zkoss.zul.Include;
import org.zkoss.zul.Timer;
import org.zkoss.zul.Window;

import demo.model.Message;
import demo.model.MessageboardManager;

/**
 * @author Ian YT Tsai(zanyking)
 *
 */
public class ExpansionArea extends Div implements IdSpace {

	private List<Message> messages;
	
	public static ExpansionArea getInstance(){
		//if Caller is certain there's an "ExpansionArea" instance in this desktop.
		return (ExpansionArea) Executions.getCurrent().getDesktop().getAttribute("KEY_ExpansionArea");
	}
	
	public ExpansionArea(){// I'm very sure for each desktop, there should be only one "ExpansionArea" 
		Executions.getCurrent().getDesktop().setAttribute("KEY_ExpansionArea", this);
		
		messages = MessageboardServlet.getMessages(
				(HttpServletRequest)Executions.getCurrent().getNativeRequest());	
	}

	public void update(){
		List<Message> newMesgs = MessageboardManager.getInstance().getMessageboard().getMessages();
		List<Message> delta = new ArrayList<Message>(newMesgs); 
		delta.removeAll(messages);
		for(Message mesg : delta){
			post(mesg);
		}
		messages = newMesgs;		
	}
	
	private void post(Message message){
		Include zInclude = new Include();
		zInclude.setSrc("/WEB-INF/_message.jsp");
		zInclude.setDynamicProperty("message", message);
		zInclude.setParent(this);
	}
		
}
