/**
 * 
 */
package demo;

import java.util.Date;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Desktop;
import org.zkoss.zk.ui.Page;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zk.ui.util.GenericForwardComposer;
import org.zkoss.zul.Include;
import org.zkoss.zul.Timer;

import demo.model.Messageboard;
import demo.model.MessageboardManager;
import demo.model.UserManager;

/**
 * @author Ian YT Tsai(zanyking)
 *
 */
public class MessageboardViewCtrl extends GenericForwardComposer {

	
	private Timer timer;
	private PostArea postArea;
	
	private Date lastMessageUpdate;
	private Date lastAttendeesUpdate;
	
	
	public void doAfterCompose(final Component comp) throws Exception {
		super.doAfterCompose(comp);
		
		//if there's no time for UserManager concept, use these lines. 
		//postArea = new PostArea();
		//postArea.setParent(comp);
		
		if(UserManager.getInstance().getUser()!=null){
			postArea = new PostArea();
			postArea.setParent(comp);
		}
		
		UserManager.getInstance().subscribe(new EventListener() {
			public void onEvent(Event event) throws Exception {
				
				Desktop desktop = comp.getDesktop();
				if(desktop==null || !desktop.isAlive()){
					UserManager.getInstance().unsubscribe(this);
					return;
				}
				
				if(UserManager.ON_USER_JOIN.equals(event.getName())){
					postArea = new PostArea();
					postArea.setParent(comp);
				}else if(UserManager.ON_USER_LEAVE.equals(event.getName())){
					postArea.detach();
					postArea = null;
				}
			}
		});
		
		lastAttendeesUpdate = MessageboardServlet.getLastAttendeesUpdateDate(
				(HttpServletRequest) execution.getNativeRequest());
		lastMessageUpdate =  MessageboardServlet.getLastMessagesUpdateDate(
				(HttpServletRequest) execution.getNativeRequest());
		
		timer.setRepeats(true);
		timer.setDelay(2000);
		timer.start();
	}

	
	public void onTimer$timer(){
		Messageboard mesgBd = MessageboardManager.getInstance().getMessageboard();
		
		Date currentAttendeesUpdate = mesgBd.getLastAttendeesUpdateDate();
		if(!lastAttendeesUpdate.equals( currentAttendeesUpdate)){
			AttendeesPanelViewCtrl.getInstance().refreshAttendeesGrid();			
			lastAttendeesUpdate = currentAttendeesUpdate;
		}
		
		Date currentMessagesUpdate = mesgBd.getLastMessagesUpdateDate();
		if(!lastMessageUpdate.equals(currentMessagesUpdate)){
			ExpansionArea.getInstance().update();
			lastMessageUpdate = currentMessagesUpdate;
		}
	}
	
	
	
	
}
