/**
 * 
 */
package demo;

import java.util.List;

import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.util.GenericForwardComposer;
import org.zkoss.zul.Button;
import org.zkoss.zul.Cell;
import org.zkoss.zul.Grid;
import org.zkoss.zul.Image;
import org.zkoss.zul.Label;
import org.zkoss.zul.ListModelList;
import org.zkoss.zul.Row;
import org.zkoss.zul.RowRenderer;
import org.zkoss.zul.Vlayout;

import demo.model.MessageboardManager;
import demo.model.User;
import demo.model.UserManager;

/**
 * @author Ian YT Tsai(zanyking)
 *
 */
public class UserPanelViewCtrl extends GenericForwardComposer {

	private Button userBtn;
	private Grid userGrid;
	
	public static UserPanelViewCtrl getInstance(){
		return (UserPanelViewCtrl) Executions.getCurrent().getDesktop().getAttribute("KEY_UserPanelViewCtrl");
	}
	public void doAfterCompose(final Component comp) throws Exception {
		super.doAfterCompose(comp);
		Executions.getCurrent().getDesktop().setAttribute("KEY_UserPanelViewCtrl", this);
		refreshUserGrid();	
		userGrid.setRowRenderer(new RowRenderer() {
			public void render(Row row, Object data) throws Exception {
				User user = (User) data;
				Vlayout cell = new Vlayout();
				new Image("/resource/user.png").setParent(row);
				new Label(user.getName()).setParent(cell);
				new Label(user.getEmail()).setParent(cell);
				cell.setParent(row);
				new Label(""+Cons.hh_mm_dd_MMM_yyyy.format(user.getJoinDate())).setParent(row);
			}
		});
	}

	public void refreshUserGrid(){
		List<User> users = MessageboardManager.getInstance().getMessageboard().getAttendees();
		userGrid.setModel(new ListModelList(users));
	}
	
	public void onClick$userBtn()throws Exception{
		if(UserManager.getInstance().getUser()!=null){
			return;
		}
		JoinDialog dialog = new JoinDialog();
		dialog.open(page);
	}

	
}
