/**
 * 
 */
package demo.model;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.List;

import demo.Cons;

/**
 * @author Ian YT Tsai(zanyking)
 *
 */
public class Messageboard {

	public Messageboard(){
		dummyData(this);
	}
	
	private final List<Message> messageStore = 
		Collections.synchronizedList(new ArrayList<Message>());
	private volatile Date lastMessagesUpdateDate = new Date();
	
	public List<Message> getMessages(){
		return new ArrayList<Message>(messageStore);
	}
	public void add(Message message){
		messageStore.add(message);
		lastMessagesUpdateDate = new Date();
	}
	public Date getLastMessagesUpdateDate(){
		return lastMessagesUpdateDate;
	}
	
	
	private final List<User> attendeeStore = 
		Collections.synchronizedList(new ArrayList<User>());
	private volatile Date lastAttendeesUpdateDate = new Date();
	public List<User> getAttendees(){
		return new ArrayList<User>(attendeeStore);
	}
	public synchronized void join(User user){
		if(!attendeeStore.contains(user)){
			attendeeStore.add(user);
			lastAttendeesUpdateDate = new Date();
		}
	}
	public void leave(User user){ 
		if(attendeeStore.remove(user)){
			lastAttendeesUpdateDate = new Date();
		}
	}
	public Date getLastAttendeesUpdateDate() {
		return lastAttendeesUpdateDate;
	}
	
	// -----------------------------------------------------------------------
	
	private static void dummyData(Messageboard mesgBoard){
		mesgBoard.attendeeStore.add(Cons.IANTSAI);
		mesgBoard.attendeeStore.add(Cons.TIM);
		Message message = new Message();
		message.setContent("Hi, this is <b>Tim</b>, nice to see you!");
		message.setCreateDate(new Date());
		message.setUser(Cons.TIM);
		mesgBoard.messageStore.add(message);
		message = new Message();
		message.setContent("Hi, this is <b>Ian Tsai</b>!");
		message.setCreateDate(new Date());
		message.setUser(Cons.IANTSAI);
		mesgBoard.messageStore.add(message);

	}
	
}
